/*ADMIN MOD MEN

Das Men hat vier feste Hauptkategorien. Jede Kategorie hat ihre eigene
*.cfg Datei,in der die Befehle:Accesslevel eingetragen werden.
Mit "ammenu" im chat wird dann das Menu aufgerufen.

Konfiguration:
- Speicherort der *.cfg Dateien: addond/adminmod/config/ammenu/
- PlayerCommands: playercommands.cfg
- MapCommands:mapcommands.cfg
- ServerCommands: servercommands.cfg
- VoteCommands: votecommands.cfg
- Maps: maps.cfg (sind fr die MapCommands wichtig!)
- amv_enable_beta "menu1" muss in der adminmod.cfg stehen.

Befehle:
Im chat "ammenu". Der Befehl "am_menu" in der Konsole dient nur zur bersicht/Kontrolle.

Sonstiges:
Wie man an den Beispiel.cfg Dateien sieht, habe ich abundzu eine Beschreibung:999999 eingebaut,
um eine etwas bessere Strukturreinzubekommen. Auch habe ich in den Beispiel.cfg Dateien die Befehle
so sortiert, wie sie am hufigsten benutzt werden

*/

#include <core>
#include <string>
#include <admin>
#include <plugin>
#include <adminlib>

#pragma dynamic 16384

new AM_VERSION_STRING[] = "2.50.10";

/****************************************/
/* 	EDIT MAX COMMANDS AVAILABLE	*/
/*	FROM COMMANDS-FILE (MAX 100!!)	*/
/****************************************/
#define MAX_PLAYER_COMMANDS 	40
#define MAX_MAP_COMMANDS	40
#define MAX_SERVER_COMMANDS	80
#define MAX_VOTE_COMMANDS	40
/****************************************/
#define MAX_MAPS		60
/****************************************/

new g_PlayerCommandFile[]="addons/adminmod/config/ammenu/playercommands.cfg";
new g_MapCommandFile[]="addons/adminmod/config/ammenu/mapcommands.cfg";
new g_MapFile[]="addons/adminmod/config/ammenu/maps.cfg";
new g_ServerCommandFile[]="addons/adminmod/config/ammenu/servercommands.cfg";
new g_VoteCommandFile[]="addons/adminmod/config/ammenu/votecommands.cfg";


new g_Maps[MAX_MAPS][MAX_NAME_LENGTH];
new g_lmaps;

/*MENUES*/
/*EBENE 1*/
#define MAINMENU	1
/*EBENE 2*/
#define PLAYERMENU	2
#define MAPMENU		3
#define SERVERMENU	4
#define VOTEMENU	5
/*EBENE 3*/
#define PLAYERSELECT	6
#define MAPSELECT	7
/*EBENE 4*/
#define EXECUTEMENU	8

new g_PlayerCommands[MAX_PLAYER_COMMANDS][MAX_COMMAND_LENGTH];
new g_PCAccess[MAX_PLAYER_COMMANDS][MAX_NUMBER_LENGTH];
new g_MapCommands[MAX_MAP_COMMANDS][MAX_COMMAND_LENGTH];
new g_MCAccess[MAX_MAP_COMMANDS][MAX_NUMBER_LENGTH];
new g_ServerCommands[MAX_SERVER_COMMANDS][MAX_COMMAND_LENGTH];
new g_SCAccess[MAX_SERVER_COMMANDS][MAX_NUMBER_LENGTH];
new g_VoteCommands[MAX_VOTE_COMMANDS][MAX_COMMAND_LENGTH];
new g_VCAccess[MAX_VOTE_COMMANDS][MAX_NUMBER_LENGTH];

new g_lplayercommands;
new g_lmapcommands;
new g_lservercommands;
new g_lvotecommands;


/*USER SELECTS*/
new g_UserMenu[MAX_PLAYERS];
new g_UserLastMenu[MAX_PLAYERS];
new g_UserLastSelectLoop[MAX_PLAYERS]={1,1,...};
new g_UserMessageMode[MAX_PLAYERS];
new g_UserSelectLoop[MAX_PLAYERS]={1,1,...};
new g_UserCommand[MAX_PLAYERS][MAX_COMMAND_LENGTH];
new g_UserCommandData[MAX_PLAYERS][MAX_DATA_LENGTH];
new g_PlayerList[MAX_PLAYERS];

public plugin_init(){
	new Menu[MAX_NAME_LENGTH];
	getstrvar("amv_enable_beta",Menu,MAX_NAME_LENGTH);
	if(strstrx(Menu,"menu1")!=-1){
		new Text[MAX_TEXT_LENGTH];
		plugin_registerinfo("Admin Mod Menu","Administrate your server with menu",AM_VERSION_STRING);
		plugin_registercmd("am_menu","am_menu",ACCESS_MAP,"am_menu: displays all loaded commands");
		plugin_registercmd("say","HandleSay",ACCESS_ALL,"ammenu: opens the admin mod menu");
		plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
		plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
		plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
		plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
		read_file(g_PlayerCommandFile,g_PlayerCommands,g_PCAccess,MAX_PLAYER_COMMANDS,g_lplayercommands);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Es wurden %i Spielerbefehle geladen",g_lplayercommands);
		selfmessage(Text);
		strinit(Text);
		read_file(g_MapCommandFile,g_MapCommands,g_MCAccess,MAX_MAP_COMMANDS,g_lmapcommands);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Es wurden %i Mapbefehle geladen",g_lmapcommands);
		selfmessage(Text);
		strinit(Text);
		read_file(g_ServerCommandFile,g_ServerCommands,g_SCAccess,MAX_SERVER_COMMANDS,g_lservercommands);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Es wurden %i Serverbefehle geladen",g_lservercommands);
		selfmessage(Text);
		strinit(Text);
		read_file(g_VoteCommandFile,g_VoteCommands,g_VCAccess,MAX_VOTE_COMMANDS,g_lvotecommands);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Es wurden %i Votebefehle geladen",g_lvotecommands);
		selfmessage(Text);
		strinit(Text);
		new dummy[1][1];
		read_file(g_MapFile,g_Maps,dummy,MAX_MAPS,g_lmaps);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Es wurden %i Maps geladen",g_lmaps);
		selfmessage(Text);
		strinit(Text);
	}else{
		plugin_registerinfo("Admin Mod Menu","Script is disabled, because 'amv_enable_beta menu1' is not set in adminmod.cfg!",AM_VERSION_STRING);
	}
	return PLUGIN_CONTINUE;
}

read_file(File[],StoreArray[][],AccessArray[][],max_entries,&loaded){
	new Data[MAX_DATA_LENGTH];
	new iFileSize;
	new i;
	
	if(fileexists(File)){
		iFileSize=filesize(File);
		for(i=1;i<=iFileSize;i++){
			if(loaded==max_entries){
				break;
			}
			readfile(File,Data,i,MAX_NAME_LENGTH);
			if(strncmp(Data,"//",2)!=0 && strncmp(Data,"#",1)!=0 && strncmp(Data,";",1)!=0 && strlen(Data)!=0){
				loaded++;
				strsplit(Data,":",StoreArray[loaded],MAX_COMMAND_LENGTH,AccessArray[loaded],MAX_NUMBER_LENGTH);
			}
		}
	}else{
		snprintf(Data,MAX_DATA_LENGTH,"[ADMIN MENU] %s konnte nicht gefunden werden!",File);
		selfmessage(File);
	}
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		reset_array(UserIndex);
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN MENU] Menue wurde durch ein anderes Menue beendet!");
		messageex(UserName,Text,print_chat);
	}
	return PLUGIN_CONTINUE;
}


/*MENUES*/
main_menu(UserName[],UserIndex){
	new Text[512];
	new keys=527;
	snprintf(Text,MAX_TEXT_LENGTH,"\w[ADMIN MOD MENU]^n^n\y1. PLAYER COMMANDS^n2. MAP COMMANDS^n3. SERVER COMMANDS^n4. VOTE COMMANDS^n^n\w0. CANCEL");
	g_UserMenu[UserIndex]=MAINMENU;
	menu(UserName,Text,keys);
}

second_menu(UserName[],UserIndex,menuID){
	new Data[100][MAX_NAME_LENGTH];
	new Alvl[100][MAX_NUMBER_LENGTH];
	new Text[512];
	new a=1;
	new keys=0;
	new i;
	new x;
	new loaded;
	
	/*WHICH DATA SHALL BE DISPLAYED*/
	switch(menuID){
		case PLAYERMENU: {
			snprintf(Text,MAX_TEXT_LENGTH,"\w[PLAYER COMMANDS]^n");
			loaded=g_lplayercommands;
			for(i=1;i<=loaded;i++){
				strcpy(Data[i],g_PlayerCommands[i],MAX_COMMAND_LENGTH);
				strcpy(Alvl[i],g_PCAccess[i],MAX_NUMBER_LENGTH);
			}
		}
		case MAPMENU:{
			snprintf(Text,MAX_TEXT_LENGTH,"\w[MAP COMMANDS]^n");
			loaded=g_lmapcommands;
			for(i=1;i<=loaded;i++){
				strcpy(Data[i],g_MapCommands[i],MAX_COMMAND_LENGTH);
				strcpy(Alvl[i],g_MCAccess[i],MAX_NUMBER_LENGTH);
			}
		}
		case SERVERMENU:{
			snprintf(Text,MAX_TEXT_LENGTH,"\w[SERVER COMMANDS]^n");
			loaded=g_lservercommands;
			for(i=1;i<=loaded;i++){
				strcpy(Data[i],g_ServerCommands[i],MAX_COMMAND_LENGTH);
				strcpy(Alvl[i],g_SCAccess[i],MAX_NUMBER_LENGTH);
			}
		}
		case VOTEMENU:{
			snprintf(Text,MAX_TEXT_LENGTH,"\w[VOTE COMMANDS]^n");
			loaded=g_lvotecommands;
			for(i=1;i<=loaded;i++){
				strcpy(Data[i],g_VoteCommands[i],MAX_COMMAND_LENGTH);
				strcpy(Alvl[i],g_VCAccess[i],MAX_NUMBER_LENGTH);
			}
		}
		case PLAYERSELECT:{
			snprintf(Text,MAX_TEXT_LENGTH,"\w[PLAYER SELECT]^n\r%s:^n",g_UserCommand[UserIndex]);
			new maxplayers=maxplayercount();
			new Player[MAX_NAME_LENGTH];
			for(i=1;i<=maxplayers;i++){
				g_PlayerList[i]=0;
				if(playerinfo(i,Player,MAX_NAME_LENGTH)){
					loaded++;
					strcpy(Data[loaded],Player,MAX_NAME_LENGTH);
					g_PlayerList[loaded]=i;
				}
			}
		}
		case MAPSELECT:{
			snprintf(Text,MAX_TEXT_LENGTH,"\w[MAP SELECT]^n\r%s:^n",g_UserCommand[UserIndex]);
			loaded=g_lmaps;
			for(i=1;i<=loaded;i++){
				strcpy(Data[i],g_Maps[i],MAX_NAME_LENGTH);
			}
		}
	}
	/*CREATE MENU*/
	for(i=g_UserSelectLoop[UserIndex];i<=loaded;i++){
		x++;
		if(x==6){
			if(loaded>g_UserSelectLoop[UserIndex]+5){
				strcat(Text,"\w^n8. Next",MAX_TEXT_LENGTH);
				keys+=128;
				break;
			}else{
				break;
			}
		}else{
			if(PLAYERMENU <= menuID <= VOTEMENU){
				if(access(strtonum(Alvl[i]),UserName)==1){
					if(x==2){
						a=2;
					}else if(x==3){
						a=4;
					}else if(x==4){
						a=8;
					}else if(x==5){
						a=16;
					}
					snprintf(Text,MAX_TEXT_LENGTH,"%s\y%i. %s^n",Text,x,Data[i]);
					keys+=a;
				}else{
					snprintf(Text,MAX_TEXT_LENGTH,"%s\r%i. %s^n",Text,x,Data[i]);
				}
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"%s\y%i. %s^n",Text,x,Data[i]);
				a+=a;
				keys=a-1;
			}		
		}
	}
	if(g_UserSelectLoop[UserIndex]>=5){
		strcat(Text,"\w^n9. Back",MAX_TEXT_LENGTH);
		keys+=256;
	}
	strcat(Text,"\r^n^n0. Cancel",MAX_TEXT_LENGTH);
	keys+=512;	
	g_UserMenu[UserIndex]=menuID;
	menu(UserName,Text,keys);
}

messagemode_menu(UserName[],UserIndex){
	new Text[512];
	new keys=513;
	snprintf(Text,MAX_TEXT_LENGTH,"\w[ADMIN MENU]^n\yBefehl: \w%s^n\yParameter:^n\w%s^n^n\yWeitere Parameter im Chat angeben!^n^n\w1. Befehl ausfuehren^n0. Cancel",g_UserCommand[UserIndex],g_UserCommandData[UserIndex]);
	g_UserMessageMode[UserIndex]=1;
	g_UserMenu[UserIndex]=EXECUTEMENU;
	menu(UserName,Text,keys);
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(g_UserMessageMode[UserIndex]==1){
		handle_data(Data,UserName,UserIndex);
		return PLUGIN_HANDLED;
	}
	if(strcmp(Data,"ammenu")==0 && access(ACCESS_MAP)){
		main_menu(UserName,UserIndex);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

/*BULDING USERCOMMAND-DATA WITH MESSAGEMODE-DATA*/
handle_data(Data[],UserName[],UserIndex){
	if(strlen(g_UserCommandData[UserIndex])==0){
		snprintf(g_UserCommandData[UserIndex],MAX_DATA_LENGTH,"%s",Data);
	}else{
		snprintf(g_UserCommandData[UserIndex],MAX_DATA_LENGTH,"%s %s",g_UserCommandData[UserIndex],Data);
	}
	messagemode_menu(UserName,UserIndex);	
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new iSelect;
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	
	if(g_UserMenu[UserIndex]!=0){
		iSelect=strtonum(Data);
		
		/*NEXT*/
		if(iSelect==8){
			g_UserSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex]+5;
			second_menu(UserName,UserIndex,g_UserMenu[UserIndex]);
		/*BACK*/
		}else if(iSelect==9){
			g_UserSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex]-5;
			second_menu(UserName,UserIndex,g_UserMenu[UserIndex]);
		/*CANCEL*/
		}else if(iSelect==10){
			if(g_UserMenu[UserIndex]==MAINMENU){
				reset_array(UserIndex);
			}else if(g_UserMenu[UserIndex]>MAINMENU && g_UserMenu[UserIndex]< PLAYERSELECT){
				reset_array(UserIndex);
				main_menu(UserName,UserIndex);
			}else if(g_UserMenu[UserIndex]>=PLAYERSELECT && g_UserMenu[UserIndex]<EXECUTEMENU){
				g_UserSelectLoop[UserIndex]=1;
				strinit(g_UserCommandData[UserIndex]);
				if(g_UserLastMenu[UserIndex]==PLAYERSELECT){
					g_UserLastMenu[UserIndex]=PLAYERMENU;
				}else if(g_UserLastMenu[UserIndex]==MAPSELECT){
					g_UserLastMenu[UserIndex]=MAPMENU;
				}
				second_menu(UserName,UserIndex,g_UserLastMenu[UserIndex]);
			}else if(g_UserMenu[UserIndex]==EXECUTEMENU){
				g_UserSelectLoop[UserIndex]=g_UserLastSelectLoop[UserIndex];
				g_UserMessageMode[UserIndex]=0;
				strinit(g_UserCommandData[UserIndex]);
				second_menu(UserName,UserIndex,g_UserLastMenu[UserIndex]);
			}				
		}else{
			if(g_UserMenu[UserIndex]==MAINMENU){
				iSelect+=1;
				switch(iSelect){
					case PLAYERMENU: second_menu(UserName,UserIndex,PLAYERMENU);
					case MAPMENU: second_menu(UserName,UserIndex,MAPMENU);
					case SERVERMENU: second_menu(UserName,UserIndex,SERVERMENU);
					case VOTEMENU: second_menu(UserName,UserIndex,VOTEMENU);
				}
				
			}else if(g_UserMenu[UserIndex]==PLAYERMENU){
				g_UserLastMenu[UserIndex]=PLAYERMENU;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				if(g_UserSelectLoop[UserIndex]>=5){
					strcpy(g_UserCommand[UserIndex],g_PlayerCommands[g_UserSelectLoop[UserIndex]+iSelect-1],MAX_COMMAND_LENGTH);
				}else{
					strcpy(g_UserCommand[UserIndex],g_PlayerCommands[iSelect],MAX_COMMAND_LENGTH);
				}
				g_UserSelectLoop[UserIndex]=1;
				second_menu(UserName,UserIndex,PLAYERSELECT);
				
			}else if(g_UserMenu[UserIndex]==MAPMENU){
				g_UserLastMenu[UserIndex]=MAPMENU;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				if(g_UserSelectLoop[UserIndex]>=5){
					strcpy(g_UserCommand[UserIndex],g_MapCommands[g_UserSelectLoop[UserIndex]+iSelect-1],MAX_COMMAND_LENGTH);
				}else{
					strcpy(g_UserCommand[UserIndex],g_MapCommands[iSelect],MAX_COMMAND_LENGTH);
				}
				g_UserSelectLoop[UserIndex]=1;
				second_menu(UserName,UserIndex,MAPSELECT);
				
			}else if(g_UserMenu[UserIndex]==SERVERMENU){
				g_UserLastMenu[UserIndex]=SERVERMENU;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				if(g_UserSelectLoop[UserIndex]>=5){
					strcpy(g_UserCommand[UserIndex],g_ServerCommands[g_UserSelectLoop[UserIndex]+iSelect-1],MAX_COMMAND_LENGTH);
				}else{
					strcpy(g_UserCommand[UserIndex],g_ServerCommands[iSelect],MAX_COMMAND_LENGTH);
				}
				messagemode_menu(UserName,UserIndex);
				
			}else if(g_UserMenu[UserIndex]==VOTEMENU){
				g_UserLastMenu[UserIndex]=VOTEMENU;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				if(g_UserSelectLoop[UserIndex]>=5){
					strcpy(g_UserCommand[UserIndex],g_VoteCommands[g_UserSelectLoop[UserIndex]+iSelect-1],MAX_COMMAND_LENGTH);
				}else{
					strcpy(g_UserCommand[UserIndex],g_VoteCommands[iSelect],MAX_COMMAND_LENGTH);
				}
				messagemode_menu(UserName,UserIndex);
		
			}else if(g_UserMenu[UserIndex]==PLAYERSELECT){
				g_UserLastMenu[UserIndex]=PLAYERSELECT;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				new Player[MAX_NAME_LENGTH];
				if(g_UserSelectLoop[UserIndex]>=5){
					playerinfo(g_PlayerList[g_UserSelectLoop[UserIndex]+iSelect-1],Player,MAX_NAME_LENGTH);
				}else{
					playerinfo(g_PlayerList[iSelect],Player,MAX_NAME_LENGTH);
				}
				snprintf(g_UserCommandData[UserIndex],MAX_NAME_LENGTH,"^"%s^"",Player);
				//strcpy(g_UserCommandData[UserIndex],Player,MAX_NAME_LENGTH);
				messagemode_menu(UserName,UserIndex);
				
			}else if(g_UserMenu[UserIndex]==MAPSELECT){
				g_UserLastMenu[UserIndex]=MAPSELECT;
				g_UserLastSelectLoop[UserIndex]=g_UserSelectLoop[UserIndex];
				if(g_UserSelectLoop[UserIndex]>=5){
					strcpy(g_UserCommandData[UserIndex],g_Maps[g_UserSelectLoop[UserIndex]+iSelect-1],MAX_NAME_LENGTH);
				}else{
					strcpy(g_UserCommandData[UserIndex],g_Maps[iSelect],MAX_NAME_LENGTH);
				}
				messagemode_menu(UserName,UserIndex);
				
			}else if(g_UserMenu[UserIndex]==EXECUTEMENU){
				if(iSelect==1){
					exec_command(UserName,UserIndex);
				}				
			}
		}
	}
	return PLUGIN_CONTINUE;
}


exec_command(UserName[],UserIndex){
	plugin_exec(g_UserCommand[UserIndex],g_UserCommandData[UserIndex]);
	messageex(UserName,"Befehl wurde ausgefuehrt!",print_chat);
	reset_array(UserIndex);
}


reset_array(UserIndex){
	g_UserMenu[UserIndex]=0;
	g_UserLastMenu[UserIndex]=0;
	g_UserLastSelectLoop[UserIndex]=1;
	g_UserMessageMode[UserIndex]=0;
	g_UserSelectLoop[UserIndex]=1;
	strinit(g_UserCommand[UserIndex]);
	strinit(g_UserCommandData[UserIndex]);
}


/*DEBUG*/
public am_menu(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new i;
	selfmessage("* PLAYER-COMMANDS:");
	for(i=1;i<=g_lplayercommands;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"- %s (%s)",g_PlayerCommands[i],g_PCAccess[i]);
		selfmessage(Text);
	}
	selfmessage("* MAP-COMMANDS:");
	for(i=1;i<=g_lmapcommands;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"- %s (%s)",g_MapCommands[i],g_MCAccess[i]);
		selfmessage(Text);
	}
	selfmessage("* SERVER-COMMANDS:");
	for(i=1;i<=g_lservercommands;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"- %s (%s)",g_ServerCommands[i],g_SCAccess[i]);
		selfmessage(Text);
	}
	selfmessage("* VOTE-COMMANDS:");
	for(i=1;i<=g_lvotecommands;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"- %s (%s)",g_VoteCommands[i],g_VCAccess[i]);
		selfmessage(Text);
	}
	selfmessage("* MAPS:");
	for(i=1;i<=g_lmaps;i++){
		selfmessage(g_Maps[i]);
	}
	return PLUGIN_HANDLED;
}
	
	